/*
 *   Copyright 2014-2023 IHE International
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.12.25 at 01:02:08 PM CET 
//

package net.ihe.gazelle.audit.message.desc;

import org.jboss.seam.annotations.Name;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.*;
import java.io.Serializable;

/**
 * <p>
 * Java class for AuditSourceDescription complex type.
 * 
 * <p>
 * The following schema fragment specifies the expected content contained within
 * this class.
 * 
 * <pre>
 * &lt;complexType name=&quot;AuditSourceDescription&quot;&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base=&quot;{http://www.w3.org/2001/XMLSchema}anyType&quot;&gt;
 *       &lt;sequence&gt;
 *         &lt;element name=&quot;AuditSourceID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;AuditEnterpriseSiteID&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *         &lt;element name=&quot;AuditSourceTypeCode&quot; type=&quot;{}ElementDescription&quot;/&gt;
 *       &lt;/sequence&gt;
 *       &lt;attribute name=&quot;cardinality&quot; type=&quot;{}Cardinality&quot; default=&quot;0..1&quot; /&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "AuditSourceDescription", propOrder = { "auditSourceID",
		"auditEnterpriseSiteID", "auditSourceTypeCode", "auditSourceCodeValue" })
@Entity
@Name("auditSourceDescription")
@Table(name = "am_audit_source_description", schema = "public")
@SequenceGenerator(name = "am_audit_source_description_sequence", sequenceName = "am_audit_source_description_id_seq", allocationSize = 1)
public class AuditSourceDescription implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@XmlTransient
	@Id
	@GeneratedValue(generator = "am_audit_source_description_sequence", strategy = GenerationType.SEQUENCE)
	@NotNull
	@Column(name = "id")
	private Integer id;

	@XmlElement(name = "AuditSourceID", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "auditSourceID_id")
	protected ElementDescription auditSourceID;

	@XmlElement(name = "AuditEnterpriseSiteID", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "auditEnterpriseSiteID_id")
	protected ElementDescription auditEnterpriseSiteID;

	@XmlElement(name = "AuditSourceTypeCode", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "auditSourceTypeCode_id")
	protected ElementDescription auditSourceTypeCode;
	
	@XmlElement(name = "AuditSourceCodeValue", required = true)
	@ManyToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "auditSourceCodeValue_id")
	protected ElementDescription auditSourceCodeValue;

	@XmlAttribute(name = "min")
	protected String min;

	@XmlAttribute(name = "max")
	protected String max;

	public ElementDescription getAuditSourceCodeValue() {
		return auditSourceCodeValue;
	}

	public void setAuditSourceCodeValue(ElementDescription auditSourceCodeValue) {
		this.auditSourceCodeValue = auditSourceCodeValue;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * Gets the value of the auditSourceID property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getAuditSourceID() {
		return auditSourceID;
	}

	/**
	 * Sets the value of the auditSourceID property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setAuditSourceID(ElementDescription value) {
		this.auditSourceID = value;
	}

	/**
	 * Gets the value of the auditEnterpriseSiteID property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getAuditEnterpriseSiteID() {
		return auditEnterpriseSiteID;
	}

	/**
	 * Sets the value of the auditEnterpriseSiteID property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setAuditEnterpriseSiteID(ElementDescription value) {
		this.auditEnterpriseSiteID = value;
	}

	/**
	 * Gets the value of the auditSourceTypeCode property.
	 * 
	 * @return possible object is {@link ElementDescription }
	 * 
	 */
	public ElementDescription getAuditSourceTypeCode() {
		return auditSourceTypeCode;
	}

	/**
	 * Sets the value of the auditSourceTypeCode property.
	 * 
	 * @param value
	 *            allowed object is {@link ElementDescription }
	 * 
	 */
	public void setAuditSourceTypeCode(ElementDescription value) {
		this.auditSourceTypeCode = value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = (prime * result)
				+ ((auditEnterpriseSiteID == null) ? 0 : auditEnterpriseSiteID
						.hashCode());
		result = (prime * result)
				+ ((auditSourceID == null) ? 0 : auditSourceID.hashCode());
		result = (prime * result)
				+ ((auditSourceTypeCode == null) ? 0 : auditSourceTypeCode
						.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AuditSourceDescription other = (AuditSourceDescription) obj;
		if (auditEnterpriseSiteID == null) {
			if (other.auditEnterpriseSiteID != null) {
				return false;
			}
		} else if (!auditEnterpriseSiteID.equals(other.auditEnterpriseSiteID)) {
			return false;
		}
		if (auditSourceID == null) {
			if (other.auditSourceID != null) {
				return false;
			}
		} else if (!auditSourceID.equals(other.auditSourceID)) {
			return false;
		}
		if (auditSourceTypeCode == null) {
			if (other.auditSourceTypeCode != null) {
				return false;
			}
		} else if (!auditSourceTypeCode.equals(other.auditSourceTypeCode)) {
			return false;
		}
		return true;
	}

	public String getMin() {
		if (min == null) {
			min = "0";
		}
		return min;
	}

	public void setMin(String min) {
		if (min == null) {
			min = "0";
		}
		this.min = min;
	}

	public String getMax() {
		if (max == null) {
			max = "*";
		}
		return max;
	}

	public void setMax(String max) {
		if (max == null) {
			max = "*";
		}
		this.max = max;
	}

}
